/*
 * nv_get_nowait.c
 *       novasub rouitines
 *              version 1.01  24-SEP-1992 Masaharu NOMACHI   (KEK)
 */

#include "novalib.h"
#include "nova.h"

/*
 * nova_get_nowait()
 *
 */
int nova_get_nowait(nd, address, length)
     struct NOVAD *nd; char **address; int *length;
{
  int rval,offset,size,pid;

  /*
   * get message from the buffer manager
   */
#ifdef VXWORKS
  rval = msgQReceive(nd->rcv_msgid, nd->buffer->mtext, NV_MSGLEN, NO_WAIT);
#else
  rval = msgrcv(nd->rcv_msgid,nd->buffer, NV_MSGLEN,nd->rcv_type,IPC_NOWAIT);
#endif
  if (rval < 0) {
    if (errno == EINTR)  return 1;
#ifndef VXWORKS
    if (errno == ENOMSG) return 1;
#endif
    perror("nv_get: receive message");
    return -1;
  }
  rval = sscanf(nd->buffer->mtext,"ready:%d:%d:%d",&pid,&offset,&size);
  if (rval != 3) {
    printf("nv_get: wrong message is returned %s\n",nd->buffer->mtext);
    return -1;
  }
  if ( pid != (nd->pid)) {
    printf("nv_get: wrong pid is returned %d/%d\n",pid,nd->pid);
    return -1;
  }
  if (offset == 0 && size == 0) {
      *address = 0;
      *length = 0;
      return 1;
  }
  else {
      *address = (char *)((int)nd->base + offset);
      *length  = size;
      return 0;
  }
}


