/*
 * nnv_read.c
 *       nova net sub rouitines
 *              version 1.03  09-OCT-1992 Masaharu NOMACHI   (KEK)
 */

#include "novanet.h"
#include "nova.h"

/*
 * net_nova_read()
 *
 */
int net_nova_read(nd, address, length)
     struct NOVAD *nd; char *address; int length;
{
  int rval,size,j;

  if (nd->priority <= 0) return -1;
  /*
   * get buffer size
   */
  rval = nnv_read(nd->sd, nd->net_msg, 24);
  if (rval ==0) return -2;
  if (rval < 0 ) {
/*    printf("nnv_get: reading socket %X\n",errno);   */
    return -1;
  }
  rval = sscanf(nd->net_msg,"nova:%X:",&size);
  if (rval != 1) return 0;       /* timeout */

  /*
   * get buffer.  Try twice, just in case a signal comes at the wrong time.
   * This may only happen in a UNIDAQ environment.  Only size<=length is
   * taken care of in this way.
   */
  if (size <= length) {
    for (j=0; j<2; j++) {
      rval = nnv_read(nd->sd, address, size);
      if (rval ==0) return -2;
      else if (rval < 0 ) {
/*      printf("nnv_get: reading socket %X\n",errno);  */
        if (j==1) return -1;
      }
      else {
        return rval;
      }
    }
  }
  else {
    rval = nnv_read(nd->sd, address, length);
    if (rval ==0) return -2;
    if (rval < 0) return -1;
    size -= length;
    rval = nnv_skip(nd->sd, size);
    if (rval ==0) return -2;
    if (rval < 0) return -1;
    return length;
  }
}


