/*
 * nnv_read_with_sig.c
 *       nova net sub rouitines
 *              version 2.00  22-FEB-1994 Masaharu NOMACHI   (KEK)
 */

#include "novanet.h"
#include "nova.h"

/*
 * net_nova_read_with_sig()
 *
 */
int net_nova_read_with_sig(nd, address, length, r_length, r_significance)
     struct NOVAD *nd; char *address; int length;
     int *r_length, *r_significance;
{
  int rval,size,j;

  *r_length = 0;
  *r_significance = 0;

  if (nd->priority <= 0) return -1;
  /*
   * get buffer size
   */
  rval = nnv_read(nd->sd, nd->net_msg, 24);
  if (rval ==0) return -2;
  if (rval < 0 ) {
/*    printf("nnv_get: reading socket %X\n",errno);  */
    return -1;
  }

/*  printf("%s\n",nd->net_msg);  */

  rval = sscanf(nd->net_msg,"nova:%X:%X",r_length,r_significance);
  if (rval != 2) return 0;       /* timeout */
  size = *r_length;

  /*
   * get buffer.  Try twice, just in case a signal comes at the wrong time.
   * This may only happen in a UNIDAQ environment.  Only size<=length is
   * taken care of in this way.
   */
  if (size <= length) {
    for (j=0; j<2; j++) {
      rval = nnv_read(nd->sd, address, size);
      if (rval ==0) return -2;
      else if (rval < 0 ) {
/*      printf("nnv_get: reading socket %X\n",errno);  */
        if (j==1) return -1;
      }
      else {
	return rval;
      }
    }
  }
  else {
    rval = nnv_read(nd->sd, address, length);
    if (rval ==0) return -2;
    if (rval < 0) return -1;
    size -= length;
    rval = nnv_skip(nd->sd, size);
    if (rval ==0) return -2;
    if (rval < 0) return -1;
    return length;
  }
}


