/*
 * novad_installer.c
 *
 * Nova buffer manager install subroutine
 *
 *              version 0.2   08-JUN-1992 M. Nomachi (kek)
 *              version 0.3   22-JUN-1992 Yasuo TAKEUCHI     (T.I.T.)
 *              version 1.02  01-OCT-1992 M. Nomachi (kek)
 *		version 1.07	20-NOV-1993	Yasuo TAKEUCHI	(T.I.T.)
 */

#include "novad.h"

int exec_install(msgsock, p, shmid, pid, novaid)
     int msgsock, shmid, *pid, *novaid; struct nova_def *p;
{
  struct msgbuf *msg_buffer;
  int rval, priority, msgid, type;

  msg_buffer    = (struct msgbuf *)malloc(sizeof(long) + NV_MSGLEN);
  if ((int)msg_buffer == 0) return -1;

  /*
   * forward the message to the buffer manager
   */
  bzero(msg_buffer->mtext, NV_MSGLEN);
  rval = read(msgsock, msg_buffer->mtext, NV_MSGLEN);
  if (rval == 0) {
    printf("serv: Ending the connetion befor getting the parameters\n");
    return -1;
  }
  else if (rval < 0) {
    perror("serv: reading stream message");
    return -1;
  }
  if (send_bufmgr(p,msg_buffer) < 0) return -1;

  if (strncmp("debug",msg_buffer->mtext,5) == 0) return 1;
  else if (strncmp("dump",msg_buffer->mtext,4) == 0) {
    exec_dump(msgsock, p, msg_buffer);
    return 1;
  }
  else if (strncmp("exit_bm",msg_buffer->mtext,7) == 0) {
    return 1;
  }
  else if (strncmp("install",msg_buffer->mtext,7) != 0) {
    printf("serv: Invalid socket message %s\n",msg_buffer->mtext);
    return 1;
  }

  /*
   * receive a nova id from the buffer manager
   */
  bzero(msg_buffer->mtext, NV_MSGLEN);
  if (receive_daemon(p,msg_buffer) < 0) return -1;

  if (strncmp("err",msg_buffer->mtext,3)==0) {
    printf("serv: install error %s\n",msg_buffer->mtext);
    close(msgsock);
    return -1;
  }
  rval = sscanf(msg_buffer->mtext,"ack:%d:%d:(%d,%d)",pid,novaid,&msgid,&type);
  if (rval != 4) {
    printf("serv: invalid message from bufmgr %s\n",msg_buffer->mtext);
    close(msgsock);
    return -1;
  }

  /*
   * send a "novaid", "msgid" and "shmid" to the client process
   */
  bzero(msg_buffer->mtext, NV_MSGLEN);
  sprintf(msg_buffer->mtext,"ack:%d:%d:%d:(%d,%d):(%d,%d):%d",
	  *pid,*novaid,shmid,msgid,type,
	  p->bufmgr_msgid,p->bufmgr_type,p->buff_size);
  rval = write(msgsock, msg_buffer->mtext, strlen(msg_buffer->mtext));
  if (rval == 0) {
    printf("serv: Ending the connetion befor sending the id(s)\n");
    return -1;
  }
  else if (rval < 0) {
    perror("serv: writing stream message");
    return -1;
  }
  free((char *)msg_buffer);
  return 0;
}

int exec_dump(msgsock, p, msg_buffer)
     int msgsock; struct nova_def *p; struct msgbuf *msg_buffer; 
{
  int rval;

  while(1) {
    /*
     * receive from the buffer manager
     */
    bzero(msg_buffer->mtext, NV_MSGLEN);
    if (receive_daemon(p,msg_buffer) < 0) return -1;

    if (strncmp("end",msg_buffer->mtext,3)==0) break;
    else if (strncmp("err",msg_buffer->mtext,3)==0) {
      printf("serv: dump error %s\n",msg_buffer->mtext);
      close(msgsock);
      return -1;
    }
    else if (strncmp("dump",msg_buffer->mtext,4)!=0) {
      printf("serv: invalid message from bufmgr %s\n",msg_buffer->mtext);
      close(msgsock);
      return -1;
    }

    /*
     * send to client process
     */
    rval = write(msgsock, msg_buffer->mtext, strlen(msg_buffer->mtext));
    if (rval <= 0) {
      close(msgsock);
      return -1;
    }
    rval = write(msgsock,"!",1);
    if (rval <= 0) {
      close(msgsock);
      return -1;
    }
  }
  return 0;
}



