/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include "camlib.h"    /* for just NAF */
#ifdef VXWORKS
extern int CWLAM();
#endif

error_exit(status)
int status; {
    perror(strerror(status));
    exit(status);
}

int buffer[10000];

/* Main */
#ifdef VXWORKS
lamtest() {
    int status, i1, q, x, ii, z, mode;
#else
main() {
    int status, i, q, x, ii, z, mode;
#endif
    short j;
    int slot,function,address;

/* Initialization part */
#ifdef VXWORKS
    status = CAMOPN( );
#else
    status = CAM_Open( );
#endif
    if( status ) error_exit(status);
    printf("CAM_Open : OK\n");
    status = CSETBR(0);
    if( status ) error_exit(status);
    printf("CSETBR   : OK\n");
    status = CSETCR(0);
    if( status ) error_exit(status);
    printf("CSETCR   : OK\n");
    status = CGENZ();
    if( status ) error_exit(status);
    printf("CGENZ    : OK\n");
    status = CGENC();
    if( status ) error_exit(status);
    printf("CGENC    : OK\n");
    status = CSETI();
    if( status ) error_exit(status);
    printf("CSETI    : OK\n");
    status = CREMI();
    if( status ) error_exit(status);
    printf("CREMI    : OK\n");
#ifdef VXWORKS
    CELAM(0xffffff);
    taskSpawn("twtlam",100,0,2000,CWLAM,100,0,0,0,0,0,0,0,0,0);
    taskDelay(20); 
    i1 = 0x300;
    i(0);
    CAMAC(NAF(30,0,17),&i1,&q,&x);
    taskDelay(40);
    i(0);
    i1 = 0;
    CAMAC(NAF(30,0,17),&i1,&q,&x);
    CDLAM(); 
    CCLOSE(); 
#else
    i=0xff;
    mode = 0;
    system("date");
    while(1){
      CENLAM(0x2000);
      CWTLAM(10);
      system("date");
      CAMAC(NAF(14,0,10),&i,&q,&x);
    }
    CDSLAM(); 
#endif
}











