/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include "camlib.h"    /* for just NAF */

#define NTIMES 1

error_exit(status)
int status; {
    perror(strerror(status));
    exit(status);
}

/* Main */
main() {
    int status, i, q, x, ii, z;
    short j;
    int slot,function,address;

/* Initialization part */
    status = CAM_Open( );
    if( status ) error_exit(status);
    printf("CAM_Open : OK\n");
    status = CSETBR(0);
    if( status ) error_exit(status);
    printf("CSETBR   : OK\n");
    status = CSETCR(0);
    if( status ) error_exit(status);
    printf("CSETCR   : OK\n");
    status = CGENZ();
    if( status ) error_exit(status);
    printf("CGENZ    : OK\n");
    status = CGENC();
    if( status ) error_exit(status);
    printf("CGENC    : OK\n");
    status = CSETI();
    if( status ) error_exit(status);
    printf("CSETI    : OK\n");
    status = CREMI();
    if( status ) error_exit(status);
    printf("CREMI    : OK\n");
    slot = 3;
    while (slot > 0) {
        printf("slot ....");
        scanf("%d",&slot);
	if(slot < 0) break; 
        printf("function..... ");
        scanf("%d",&function);
        printf("address.... ");
        scanf("%d",&address);
        printf("data....");
        scanf("%d",&i);
	j = i;
	system("date");
        for(ii=0;ii<NTIMES;ii++) {
	  status = CAMACL(NAF(slot,address,function), &i, &q, &x ); 
/*	  status = CAMACW(NAF(slot,address,function), &j, &q, &x );
	  i = j&0xffff; */
	  if( status ) {
            printf("Error call did not come through %d %d!!!!!\n",status,ii);
	    break;
          }
	}
	system("date");
	if( status ) {
          printf("Error call did not come through %d !!!!!\n",status);
        }
        else {
          printf("Return data %d\n",i);
/* Modification to print data in binary*/
          printf("Switch:\t");
          for (z = 1; z < 25; z++)
             printf("%2d ", z);
          printf("\nValue:\t");
          for (z = 0; z < 24; z++)
             printf("%2d ", ((i >> z) & 01));
          printf("\n");
/*end modification*/
          printf("Camac q %d x-response %d\n",q,x);
        }
    }
    printf("CAMAC    : OK\n");
}











