/* buflib.c ...Interface to nova that provides for
   packing multiple events in a single nova buffer 
   This supercedes nv_getput.c

   A.Fry 93.02.15
*/

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/
#ifdef VXWORKS
#include <msgQLib.h>
#endif
#include "nova.h"
struct   NOVAD *nd;

static int current_position=0;
static int n_buffer=0;
static int *data;
int *base;
static int length;
static int max_sig = -1;



flush_buf()
{
 
      if (n_buffer>0) { if(max_sig <= 0) max_sig=1000;

	 data[current_position]=0;
	 current_position++;
         nova_put(nd, data,current_position*4,70);
         n_buffer=0;
	 max_sig = -1;
      }
 return 0;
} 

get_buf( next_address,max_length)
int **next_address;
int max_length;
{
      /* return the address for the next writeable location */
      if (n_buffer == 0) {
	 if (nova_get(nd, &base, &length)==1) return 1;
	    current_position = 0;
	    data = &base[0];
	    n_buffer=1;
	    max_sig = -1;
	 }
*next_address=(&data[current_position]);
return 0;
}

put_buf( max_length, event_length,buf_sig)
int event_length,max_length,buf_sig;
{   if(buf_sig > max_sig) max_sig=buf_sig;

      /* check the event length for consistency */
      if (event_length > max_length) {
         printf (" Event is too long in put_buf\n");
       }
       current_position += event_length; /* right number of words*/
	    
      if (current_position+max_length >= length/4) {
	 /* flush the current buffer and get the next */
	 data[current_position]=0;
	 nova_put(nd, data,current_position*4, 70);
	 n_buffer=0;
	 max_sig = -1;

         if (nova_get(nd, &base, &length)==1) return (1);
         data = &base[0];
	 current_position = 0;
	 n_buffer=1;
      }
return 0;
   }




