/*---------------------------------------------------------------*/
/*                                                               */
/*      user.c                                                   */
/*      Donald BRENNER                                           */
/*      Superconducting Super Collider Laboratory                */
/*      July 20, 1992                                            */
/*                                                               */
/*      Modified 2/4/93, C. Timmermans                           */
/*      Modified 4/2/93, B. Ball                                 */
/*---------------------------------------------------------------*/

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/
#ifdef VXWORKS
#include <stdioLib.h>
#else
#include <stdio.h>
#endif
#include "user.h"         /* <== Change this line as instructed  */
#include "template.h"

int Process_Event();
void Process_Idle();
char *get_name_from_args();


/*(a+out) ------------------------------------------------- */
#ifdef VXWORKS
user_main(argv[1],argv[2],argv[3],argv[4],argv[5],argv[6],argv[7],
          argv[8],argv[9],argv[10])
char *argv[11];
#else
main(argc, argv)
int argc;
char * argv[];
#endif
/*(b+out) -------------------------------------------------
Procedure Name
Main - main procedure
Synopsis
Description
main(argc, argv) is the main procedure of the dump. It
calls the template with the addresses of the Process_Event()
procedures. It also calls the Template_Init.                           

Superconducting Super Collider Laboratory 1.0
(c+out) --------------------------------------------------- */

{
   char name[NV_MAXNAME + 1];
   char sec_name[NV_MAXNAME + NOVA_HOSTNAME_MAX + 1];

#ifdef VXWORKS
  int argc = 11;
  argv[0] = "user_main";
#endif

   if(Template_Init(get_name_from_args(argc,argv)) < 0){
     printf("Process of name %s already exists\n",
	    get_name_from_args(argc,argv));
     printf("You can modify the process name by using the -n option\n");
     exit(0);
   }
   Template_Main((int (*)())Process_Event, NULL, (void(*)())Process_Idle);
}





/*(a+out) ------------------------------------------------- */
int Process_Event()
/*(b+out) -------------------------------------------------
Procedure Name
Process_Event - is used to dump the incoming data
Synopsis
Description
Process_Event() receives the buffer and display all or part of
the data. 

Superconducting Super Collider Laboratory 1.0
(c+out) --------------------------------------------------- */

{

}

/*(a+out) ------------------------------------------------- */
void Process_Idle()
/*(b+out) -------------------------------------------------
Procedure Name
Process_Idle - is used to fill idle time
Synopsis
Description
Process_Idle()

Superconducting Super Collider Laboratory 1.0
(c+out) --------------------------------------------------- */

{

}


