/*************************************************
 * CVS Log
 * mur_macros.h,v
 * Revision 1.1.1.1  1993/07/14  19:43:19  dbrenner
 * UNIDAQ 2.1 distribution - July 14,1993
 *
*************************************************/
#ifndef MUR_MACROS_HEADER
#define MUR_MACROS_HEADER
/*===========================================================================
**===========================================================================
**
** 		MURMUR MESSAGE CODE MACRO DEFINITIONS
*/

/*
** MASK DEFINITIONS
*/
#define MUR_M_FAC   0x0fffc000	    /* Facility mask */
#define MUR_M_MSG   0x00003ff8	    /* Message number mask */
#define MUR_M_SEV   0x00000007	    /* Severity mask */
#define MUR_M_SUC   0x00000001	    /* Success/fail mask */
#define MUR_M_NOSEV 0xbffffff8	    /* Facility & Message # mask (No severity)*/

/*
** BIT DEFINITIONS
*/
#define MUR_LSB_FAC 14		    /* Least significant bit of facility # */
#define MUR_LSB_MSG 3		    /* Least significant bit of message # */
#define MUR_LSB_SEV 0		    /* Least significant bit of severity */
#define MUR_MSB     31		    /* this bit always set for messages */

/*
** VMS FIELD DEFINITIONS 
*/

#define VMS_M_SEV 0x00000007
#define VMS_M_MSG 0x00007ff8
#define VMS_M_FAC 0x07ff0000
#define VMS_M_RESERVED 0xf0000000

#define VMS_LSB_SEV 0
#define VMS_LSB_MSG 3
#define VMS_LSB_FAC 16

#define VMS_SEV_WARNING 0
#define VMS_SEV_SUCCESS 1
#define VMS_SEV_ERROR   2
#define VMS_SEV_INFORM  3
#define VMS_SEV_FATAL   4

/*
** FACILITY Offset for TRANSLATING VMS to MURMUR
*/
#define MUR_VMS_FAC_OFFSET 12288

/*
** MACRO DEFINITIONS
*/
#define MUR_MSG_FACILITY(a) (((unsigned long)(a) & MUR_M_FAC) >> MUR_LSB_FAC)
#define MUR_MSG_NUMBER(a)   (((unsigned long)(a) & MUR_M_MSG) >> MUR_LSB_MSG)
#define MUR_MSG_SEVERITY(a) ((unsigned long)(a) & MUR_M_SEV)
#define MUR_MSG_SUCCESS(a)  ((unsigned long)(a) & MUR_M_SUC)
#define MUR_MSG_FAIL(a)	    (!((unsigned long)(a) & MUR_M_SUC))
#define MUR_MSG_STRIP_SEV(a)   ( (unsigned long) (a) & MUR_M_NOSEV)

/*
** SEVERITY FIELD VALUES
*/

#define MUR_SEV_SUCCESS	1
#define MUR_SEV_WARNING 2
#define MUR_SEV_INFORM 	3
#define MUR_SEV_ERROR  	4

/*
** MESSAGE FIELDS MAXIMUM VALUES
*/
#define MUR_MAX_FACILITY_NUMBER 16383
#define MUR_MAX_FACILITY_LENGTH 16
#define MUR_MAX_PREFIX_LENGTH    16
#define MUR_MAX_MNEMONIC_LENGTH 16
#define MUR_MAX_MSGTEXT_LENGTH 132
#define MUR_MAX_MSG_NUMBER 2047

#endif
