/* ////////////////////////////////////////////////////////
//
// file:    comline_win.C
// author:  C. Timmermans
// version: 2.0
// date:    3/10/93
/////////////////////////////////////////////////////// */

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include "sdc_pack_msg_c.h"
#include"operator.h"

#include <X11/Xlib.h>
#include <stdio.h>
#include<string.h>
#include<strings.h>
#include<time.h>
#include<sys/time.h>

extern char ownpname[];
extern char collector[],recorder[];

extern struct timeval t_getdata;
extern struct timeval t_getstor;

extern struct rp_def rp_but[];
extern char text_bt[][100];
extern int n_rp_but;

extern char sinkdir[100],sinkdev[100];

extern char str_privi[30];
extern char str_fname[80],str_device[100];

extern int i_message,i_privi;
extern char runcontrol[];

extern Window run_control;
extern Window storage;
extern Window run_par,rp_bt[];
extern int n_rp_but;
extern struct rp_def rp_but[];
extern int rp_ysiz, rc_ysiz;
extern XEvent report;

Window com_line;
GC cl_GC;

Window cl_But;
GC cl_ButGC;

char comm_str[MAX_STR_LEN];
char comm_str2[MAX_STR_LEN];
char comm_snd[MAX_STR_LEN];
char prompt_str[50];
char prompt_proc[50];


/* ////////////////////////////////////////////////////////////
// initializes a command line. Most commands will be transferred to runco,
// some commands are executed by operator
/////////////////////////////////////////////////////////// */
Init_win_comline()
{
  int y_pos;
#ifdef _DEBUG
  printf("Starting to initialize the command-line\n");
#endif
  if(rp_ysiz > rc_ysiz) y_pos = 270+rp_ysiz;
  else y_pos = 270+rc_ysiz;
  gui_window(&com_line,&cl_GC,0,1000,90,15,y_pos,4,1,
	     "Run Control Commands");
  gui_window(&cl_But,&cl_ButGC,&com_line,50,30,320,10,1,2,"");
  gui_display(&com_line);
  strcpy(comm_str,COMMAND);
  strcpy(prompt_str,COMMAND);
  comm_str2[0] = '\0';
}

Execute_win_comline()
{
	  if((i_message & (MSG_RUN | MSG_STOR)) > 0) {
	    if((report.xkey.window == com_line) && (report.type == KeyPress))
	      return;
	  }
	  if(report.xkey.window == com_line)    update_com_line();
	  else if(report.xkey.window == cl_But)      update_cl_But();
}

update_com_line()
/* ////////////////////////////////////////////////////////
// The command-line can be used to send commands to runco, and
// to exit operator by typing the "exit" command
/////////////////////////////////////////////////////// */
{
        char wrd[100];

	switch(report.type) {
	case Expose:
	  gui_text(&com_line,&cl_GC,5,30,comm_str2); 
	  gui_text(&com_line,&cl_GC,5,80,comm_str);
	  break;
	case KeyPress:
	  if( gui_string(report,&com_line,&cl_GC,comm_str,5,80,
                strlen(prompt_str), MAX_STR_LEN) == 1) {
	    if(i_message == MSG_PROMPT) {
	      sprintf(comm_snd,"re:prompt %s",
		      &(comm_str[strlen(prompt_str)]));
	      Send_Message(prompt_proc,comm_snd);
	      gui_display(&run_control);
	      gui_display(&run_par);
	      gui_display(&storage);
	      i_message = 0;
	      strcpy(prompt_str,COMMAND);
	      strcpy(comm_str,COMMAND);
	      comm_str2[0] = '\0';
	      gui_clear(&com_line);
	      update_com_line();
	      t_getdata.tv_sec = 0;
	      t_getstor.tv_sec = 0;
	    }
	    else if(strcasecmp(&(comm_str[strlen(prompt_str)]),"exit") == 0) {
	       sprintf(comm_snd,"EXIT");
	       Send_Message(ownpname,comm_snd);
	    }
	    else if(strcasecmp(&(comm_str[strlen(prompt_str)]),"PRIVI") == 0){ 
	       if(strcmp(ownpname,"operator") == 0) {
	         i_privi = 1;
	         strcpy(str_privi,"privileged");
	         gui_clear(&run_control);
	         report.type = Expose;
	         update_run_control();
	      }
	    }
	    else if(strcasecmp(&(comm_str[strlen(prompt_str)]),"NOPRIVI") == 0){ 
	       i_privi = 0;
	       strcpy(str_privi,"NOT privileged");
	       gui_clear(&run_control);
	       report.type = Expose;
	       update_run_control();
	    }
	    else if(strncasecmp(&(comm_str[strlen(prompt_str)]),
				"set runcontrol =",16) == 0){ 
	       sscanf(&(comm_str[16+strlen(prompt_str)]),"%s",runcontrol);
	       set_value_in_sp("runcontrol",runcontrol);
	       gui_clear(&run_control);
	       report.type = Expose;
	       update_run_control();
	    }
	    else if(sscanf(&(comm_str[strlen(prompt_str)]),"%s",wrd) > 0) {
	      sprintf(comm_snd,"%s",&(comm_str[strlen(prompt_str)]));
	      if (i_privi == 1) {
		Send_Message(runcontrol,comm_snd);
		t_getdata.tv_sec = 0;
		t_getstor.tv_sec = 0;
	      }
	      add_err_string(comm_snd);
	      if(i_privi == 1) send_err_string(Oper_Send_OK);
	      else             send_err_string(Oper_NO_Send);
	    }
	    comm_str[strlen(prompt_str)] = '\0';
   	    gui_text(&com_line,&cl_GC,5,80,comm_str);
	  }
	} 
}

update_cl_But()
/* ///////////////////////////////////////////////////////////////////
// The click-button is used to acknowledge that the operator has 
// given the right information
///////////////////////////////////////////////////////////////// */
{
  FILE *fp;
  short s;
  int i,i_run,i_trig,i_maxev,iv;
  float fv;

  switch(report.type) {
  case ButtonPress:
/* /////////////////////////////////////////////////////
// If run_info was asked
//////////////////////////////////////////////////// */
    if(i_message == MSG_RUN) {
/* ///////////////////////////////////////////////
// update the command-line
////////////////////////////////////////////// */
      gui_hide(&cl_But);
      for(i = 0;i<n_rp_but;i++) {
	if(rp_but[i].rc_mod == NO) gui_display(&(rp_bt[i]));
      }
      gui_display(&run_control);
      gui_display(&storage);
      comm_str2[0] = '\0';
      gui_clear(&com_line);
      report.type = Expose;
      update_com_line();
/* //////////////////////////////////////////////
// Update the variables
//////////////////////////////////////////// */
      for(i=0;i<n_rp_but;i++){
	if(rp_but[i].rc_mod == YES) {
	  if(rp_but[i].type == REAL) {
	    sscanf(text_bt[i],"%g",&fv);
	    sprintf(comm_snd,"Set %s = %g",rp_but[i].variable,fv);
	  }
	  else if(rp_but[i].type == STRING) {
	    sprintf(comm_snd,"Set %s = %s",rp_but[i].variable,text_bt[i]);
	  }
	  else if(rp_but[i].type == INT_DEC) {
	    sscanf(text_bt[i],"%d",&iv);
	    sprintf(comm_snd,"Set %s = %d",rp_but[i].variable,iv);
	  }
	  else if(rp_but[i].type == INT_HEX) {
	    sscanf(text_bt[i],"0x%x",&iv);
	    sprintf(comm_snd,"Set %s = %d",rp_but[i].variable,iv);
	  }
	  else if(rp_but[i].type == INT_CONV) {
	    if(rp_but[i].conversion(&iv,text_bt[i],1) == 0)
	      sprintf(comm_snd,"Set %s = %d",rp_but[i].variable,iv);
	    else comm_snd[0] = '\0';
	  }
	  else comm_snd[0] = '\0';
	  if(comm_snd[0] != '\0') {
	    if(strcmp(rp_but[i].proc,"collector") == 0) 
	      Send_Message(collector,comm_snd);
	    else if(strcmp(rp_but[i].proc,"recorder") == 0) 
	      Send_Message(recorder,comm_snd);
	    else if(strcmp(rp_but[i].proc,"runcontrol") == 0) 
	      Send_Message(runcontrol,comm_snd);
	    else
	      Send_Message(rp_but[i].proc,comm_snd);
	  }
	}
      }
      Send_Message(runcontrol,"RunPar");
      add_err_string("RunPar");
      send_err_string(Oper_Send_OK);
      i_message = 0;
      t_getdata.tv_sec = 0;
/* ///////////////////////////////////////////////////////
// Modify the runparameters windows; In case the runpar
// were not given in a correct way the old situation
// is restored.
///////////////////////////////////////////////////// */
    }
/* ////////////////////////////////////////////////////
// storage info was asked
/////////////////////////////////////////////////// */
    else if(i_message == MSG_STOR) {
/* /////////////////////////////////////
// update the command_line
//////////////////////////////////// */
      gui_hide(&cl_But);
      gui_display(&run_control);
      gui_display(&run_par);
      comm_str2[0] = '\0';
      gui_clear(&com_line);
      report.type = Expose;
      update_com_line();
/* /////////////////////////////////////
// send a message to runco
///////////////////////////////////// */
      read_value_from_sp(runcontrol,"recorder",&s,recorder);
      sprintf(comm_snd,"Setpar eventsink = %s",str_fname);
      Send_Message(recorder,comm_snd);
      if(strcasecmp(str_fname,"tape") == 0) 
	sprintf(comm_snd,"Setpar device = %s",str_device);
      else if(strcasecmp(str_fname,"dummy") != 0)
	sprintf(comm_snd,"Setpar dest_dir = %s",str_device);
      Send_Message(recorder,comm_snd);
      strcpy(sinkdir,str_fname);
      strcpy(sinkdev,str_device);
      Send_Message(runcontrol,"Storage");
      add_err_string("Storage");
      send_err_string(Oper_Send_OK);
      i_message = 0;
      t_getstor.tv_sec = 0;
    } 
  }  
}
