/**************************************************************
  File:  commands.h
  Author:C. Timmermans, University of Michigan
 **************************************************************
 This file contains the definitions of the procedures that can 
 be used in the command.list.
 **************************************************************
 First the definition of the subroutine needs be entered here as:
 extern int routine();
 *************************************************************/ 
extern int send_process(), send_logbook(),update_parameters(), 
  write_begin_run(), write_end_run(),check_run_status(),
  macro_exit(),next_runnr(),prompt_process();

struct command
{
	char com[100];
	int (*act)();
};


struct command cmdtable[] =  
{
/**********************************************************
  For each procedure two fields need to be filled in:
  "command"  the way the command can be called in the 
             command.list file
  routine    the  name of the routine to be called. This routine
             should be programmed in file commands_lib.c. That file
             has additional information and examples.
 ****************************************************************/
        "ask",                 send_process,
	"send_logbook",        send_logbook,
	"update_parameters",   update_parameters,
	"write_begin_run",     write_begin_run,
	"write_end_run",       write_end_run,
	"check_run_status",  check_run_status,
	"exit",              macro_exit,
	"next_runnr",        next_runnr,
	"prompt_process",    prompt_process,
};

int cmdcount = sizeof(cmdtable)/sizeof(struct command);
