/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include <errno.h>
/*      #include "camlib.h"    ## for just NAF ##     */
#define NAF(n,a,f)    ((((n<<4) + a) << 5) + f)

#ifdef VXWORKS
#include<vxWorks.h>
#include<timers.h>
struct timespec tf, ts;
extern int CAMAC();
extern int CAMACL();
extern int CAMACW();
extern int CBLWAI();
extern int CBWWAI();
#else
#include<sys/time.h>
struct timeval tf,ts;
struct timezone tz;
#endif

#ifndef REPEAT    /*  Determine compilation mode, SINGLE or REPEAT */
#ifndef SINGLE
#define SINGLE    /*  Makefile defines REPEAT=REPEAT as default.   */
#endif
#endif

#ifdef REPEAT
int ntimes;
#else
#define NTIMES 1
#endif

error_exit(status)
int status; {
#ifdef SUN
    perror();
#else
    perror(strerror(status));
#endif
    exit(status);
}

/* Main */
#ifdef VXWORKS
CAMdo() {
#else
main() {
#endif
    int status, i, q, x, ii, z, bf[20000], ipr;
    char yesno[4], tmp[100];
    short j;
    int oslot,slot,function,address;

/* Initialization part:
 *  use branch=0
 *  use crate=0
 *  Query on other functions.
 */
#ifdef SUN
    status = CAMOPN( );
#else
    status = COPEN( );
#endif
    if( status ) error_exit(status);
    printf("CAM_Open : OK\n");

    status = CSETBR(0);
    if( status ) error_exit(status);
    printf("CSETBR   : OK (branch 0)\n");

    status = CSETCR(0);
    if( status ) error_exit(status);
    printf("CSETCR   : OK (crate 0)\n");

    printf ("\nIssue crate Z? [y/n] ");
    gets(yesno);
    if (yesno[0] == 'y' )  {
      status = CGENZ();
      if( status ) error_exit(status);
      printf("CGENZ    : OK\n");
    }

    printf ("\nIssue crate C? [y/n] ");
    gets(yesno);
    if (yesno[0] == 'y' )  {
      status = CGENC();
      if( status ) error_exit(status);
      printf("CGENC    : OK\n");
    }

    printf ("\nRemove crate I? [y/n] ");
    gets(yesno);
    if (yesno[0] == 'y' )  {
      status = CREMI();
      if( status ) error_exit(status);
      printf("CREMI    : OK\n");
    }
    slot = 3;
    while (slot > 0) {
        printf("slot (>0, 0=stop, <CR>=same as last) .... ");
	tmp[0] = '\0';
	gets(tmp);
	if (tmp[0] == '\0') goto sameval;
	i = 0;
	sscanf(tmp,"%d",&oslot);
	if (oslot <= 0) break;
	slot = oslot;
        printf("function................................. ");
	gets(tmp);
        sscanf(tmp,"%d",&function);
        printf("sub-address.............................. ");
	gets(tmp);
        sscanf(tmp,"%d",&address);
	if ((function > 15) && (function < 24))  {  /* write */
          printf(" data (decimal).......................... ");
	  gets(tmp);
          sscanf(tmp,"%d",&i);
	  printf (" data is %d\n", i);
	}
      sameval:
#ifdef REPEAT
	printf (" number of iterations of function ....... ");
	gets(tmp);
	sscanf(tmp,"%d",&ntimes);
	if (ntimes < 1) ntimes=1;

	if ( (function<4) && (ntimes>1) ) {
	  printf (" Print data read for each iteration [y/n] ");
	  gets(tmp);
	  if (tmp[0]!='y' && tmp[0]!='Y') ipr=0;
	  else                            ipr=1;
	}
	else                              ipr=0;

	j = i;
#ifdef VXWORKS
	clock_gettime(CLOCK_REALTIME,&tf);
#else
	gettimeofday(&tf,&tz);
#endif
        for(ii=0;ii<ntimes;ii++) {
#else
	j = i;
        for(ii=0;ii<NTIMES;ii++) {
#endif
	  errno = 0;       /*   printf and gets don't mix happily....   */
	  status = CAMAC(NAF(slot,address,function), &i, &q, &x ); 
/*	  status = CAMACW(NAF(slot,address,function), &j, &q, &x );
	  i = j&0xffff; */
#ifndef REPEAT
	  if( status ) {
            printf("Error call did not come through %d %d!!!!!\n",status,ii);
	    break;
          }
#else
	  if ( (ipr==1) && (ii<(ntimes-1)) ) {
	    printf ("Q = %d, X = %d\n",q,x);
	    if (q == 1) {
              printf("Return data %d decimal, %o octal, %X hex\n",i,i,i);
/* Modification to print data in binary*/
              printf("Switch:\t");
              for (z = 1; z < 25; z++)
                 printf("%2d ", z);
              printf("\nValue:\t");
              for (z = 0; z < 24; z++)
                 printf("%2d ", ((i >> z) & 01));
              printf("\n");
/*end modification*/
	    }
	  }
#endif
	}
#ifdef REPEAT
#ifdef VXWORKS
	clock_gettime(CLOCK_REALTIME,&ts);
	printf("All operations took %f seconds\n",
	   1.0*(ts.tv_sec-tf.tv_sec)+(ts.tv_nsec-tf.tv_nsec)/1.0e9);
	
#else
	gettimeofday(&ts,&tz);
	printf("All operations took %f seconds\n",
	   1.0*(ts.tv_sec-tf.tv_sec)+(ts.tv_usec-tf.tv_usec)/1.0e6);
#endif
#endif
	printf ("Q = %d, X = %d\n",q,x);
	if( status ) {
          printf("Error call did not come through %d !!!!!\n",status);
        }
        else if (function<4  && q==1) {
          printf("Return data %d decimal, %o octal, %X hex\n",i,i,i);
/* Modification to print data in binary*/
          printf("Switch:\t");
          for (z = 1; z < 25; z++)
             printf("%2d ", z);
          printf("\nValue:\t");
          for (z = 0; z < 24; z++)
             printf("%2d ", ((i >> z) & 01));
          printf("\n");
/*end modification*/
        }
    }
    printf("CAMAC    : OK\n");
}

