/*************************************************
 * Start.c,v
*************************************************/
/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include<stdio.h> 
#include<netdb.h>

char cmd[500];

main()
{
  char *nn,ch;
  char fnam[200],snd_node[100],muradd[100],optype[100];

  FILE *fp,*fd;
  char answer[20],tmp[50],unidaq[100];
  int lp,sd;
  struct servent *ser;

/* /////////////////////////////////////////////
// Check murmur_server_add
////////////////////////////////////////////// */
  muradd[0] = '\0';
  if(getenv("MURMUR_SERVER_ADD") == NULL) {
    printf("The environmental variable MURMUR_SERVER_ADD does not exist.\n");
    printf(
       "This variable is filled with the IP-address of the murmur-server.\n");
    printf("Do you wish to Exit, Continue without murmur or Set the variable");
    printf(" (E,C,S)\n");
    lp = 0;
    while (lp == 0){
      printf("(E,C,S)>>");
      gets(tmp);
      answer[0]='\0';
      sscanf(tmp,"%s",answer);
      if(answer[0] == 'e' || answer[0] == 'E') exit(0);
      if(answer[0] == 'c' || answer[0] == 'C') lp = 1;
      if(answer[0] == 's' || answer[0] == 'S') {
	lp = 1;
	murmur_default(muradd);
      }
    }
  }
  else {
    strcpy(muradd,getenv("MURMUR_SERVER_ADD"));
  }
  if(decode_filename("$(USERUNIDAQ)/conf/nodefile",fnam) < 0) {
    printf("Cannot decode USERUNIDAQ (/conf/nodefile)\n");
    exit(1);
  }
  if((fp = fopen(fnam,"r")) == NULL) {
    printf("Cannot open %s\n",fnam);
    exit(1);
  }
  ser = getservbyname("exec","tcp");
  lp = 0;
  while(fscanf(fp,"%s",snd_node) > 0) {
    fscanf(fp,"%s",optype);
    nn = snd_node;
    get_unidaq(snd_node,unidaq);
    if(strcasecmp(optype,"UNIX") == 0){
      if(muradd[0] != '\0'){
	sprintf(cmd,
   "setenv MURMUR_SERVER_ADD %s;source %s/setup.csh;Start_local >& /dev/null",
		muradd,unidaq);
      }
      else {
	sprintf(cmd,
		"source %s/setup.csh;Start_local >& /dev/null", unidaq);
      }
      if((sd = rexec(&nn,ser->s_port,NULL,NULL,cmd,0)) < 0) {
	printf("An error occured\n");
	exit(-1);
      } 
      fd=fdopen(sd,"r");
      while (getc(fd) != EOF) ;
      fclose(fd);
      printf("Started on %s\n",nn);
    }
  }
  fclose(fp);
  printf("Started all nodes\n");
}

/****************************************************/
murmur_default(m)
char *m;
{
  FILE *fp;
  char fnam[200],wrd[100],tmp[100];
  int i_go;

  *m = '\0';
  if(decode_filename("$(TOPUNIDAQ)/murmur_client/error/inc/murmur_env_alias",
		     fnam) < 0) {
    printf("Cannot decode TOPUNIDAQ (...murmur_env_alias file)\n");
    exit(1);
  }
  if((fp = fopen(fnam,"r")) == NULL) {
    printf("Cannot open %s\n",fnam);
    exit(1);
  }
  i_go = 1;
  while(i_go == 1) {
    if(fscanf(fp,"%s",wrd) <= 0) i_go = 0;
    else {
      if(strcmp(wrd,"MURMUR_SERVER_ADD") == 0) {
        if(fscanf(fp,"%s",wrd) > 0) 
	  strcpy(m,wrd);
	i_go = 0;
      }
    }
  }
  fclose(fp);
  printf("Please give the IP address [ <CR> = %s ]\n",m);
  wrd[0] = '\0';
  tmp[0] = '\0';
  gets(tmp);
  sscanf(tmp,"%s",wrd);
  if(wrd[0] != '\0') strcpy(m,wrd);
}
/*************************************************/
get_unidaq(host,uni)
char *host,*uni;
{
  char tmp[100],wrd[100];

  strcpy(uni,getenv("USERUNIDAQ"));
  printf("Please give $USERUNIDAQ at node %s\n",host);
  printf("[ <CR> = %s ]",uni);
  tmp[0] = '\0';
  wrd[0] = '\0';
  gets(tmp);
  sscanf(tmp,"%s",wrd);
  if(wrd[0] != '\0') strcpy(uni,wrd);
}
/****************************************************/



