/*************************************************
 * ps_status.c,v
*************************************************/
/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include <stdio.h>

#define	TRUE		1
#define FALSE		0

/*(a+out) ------------------------------------------------- */
main (argc, argv)
int argc;
char *argv[];
/*(b+out) ------------------------------------------------- 
Procedure Name
Main - main procedure of rmcomd
Synopsis
Description
main() is the main procedure of rmcomd.  Rmcomd is a 
command which deletes an process left over from 3po.

Superconducting Super Collider Laboratory 1.0
(c+out) --------------------------------------------------- */

{
   FILE *file_handle;
   char temp[100], command[100];
   char one[100], two[100], three[100], four[100], five[100];
   char temp1[100], temp2[100], temp3[100], temp4[100], temp5[100];
   char *check;
   
   strcpy(command, "ps -x >i_ipcs");
   system(command);


   strcpy(command, "i_ipcs");

   file_handle = fopen(command, "r");
   if (file_handle == NULL) {
      printf("Error in fopen()...\n");
      return TRUE;
   }
 
   do {  

       check = fgets(temp, 100, file_handle);
       if (check != NULL) {

          Parse(temp, one, temp1);
          Parse(temp1, two, temp2);
          Parse(temp2, three, temp3);
          Parse(temp3, four, temp4);
          Parse(temp4, five, temp5);

          if (strncmp(five, "runcontrol",10) == 0) {
          	printf("runcontrol  - alive\n");
          }
          else if (strncmp(five, "dump",4) == 0) {
             printf("dump       - alive\n");
					} 
          else if (strncmp(five, "analyzer",7) == 0) {
             printf("analyzer   - alive\n");
          } 
          else if (strncmp(five, "recorder",6) == 0) {
             printf("recorder   - alive\n");
          } 
          else if (strncmp(five, "collector",9) == 0) {
             printf("collector  - alive\n");
          } 
          else if (strncmp(five, "pseudo",6) == 0) {
             printf("pseudo     - alive\n"); 
          } 
          else if (strncmp(five, "bufm",4) == 0) {
             printf("NOVA       - alive\n");
          } 

       }
   }while(check != NULL); 
 
   fclose(file_handle);
   strcpy(command, "rm i_ipcs");
   system(command);

   return TRUE;

}


/*---------------------------------------------------------------*/
/*  Parse(string, first, rest) parses a given string.            */
/*  string: the string that will be parsed,                      */
/*  first : the first word in the string,                        */
/*  rest  : the rest of the string after the first word removed. */
/*---------------------------------------------------------------*/
Parse(string, first, rest)
char *string, *first, *rest;
{
   int  i, j;
 
   i = 0;
   while (((string[i]==' ') | (string[i]=='\t') | (string[i]=='\0')) & (i < strlen(string)))
      i++;
   j = i;
   if (string[j] == '=') j++;
   else while (((string[j] != ' ') & (string[j] != '\t') &
                (string[j] != '=')) & (j < strlen(string))) j++;
   strncpy(first, string+i, j-i);
   first[j-i] = '\0';
   strcpy(rest, string+j);
}
 

