/*************************************************
 * pseudo.c,v
*************************************************/
/*---------------------------------------------------------------*/
/*                                                               */
/*      Cengiz ERBAS                                             */
/*      Superconducting Super Collider Laboratory                */
/*      June 20, 1992                                            */
/*                                                               */
/*---------------------------------------------------------------*/

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <signal.h>
#include <errno.h>
#include "template.h"
#include "ask.h"

/*(a+out) ------------------------------------------------- */
main (argc, argv)
int argc;
char *argv[];
/*(b+out) ------------------------------------------------- 
Procedure Name
Main - main procedure of pseudo
Synopsis
Description
main() is the main procedure of pseudo.

Superconducting Super Collider Laboratory 1.0
(c+out) --------------------------------------------------- */

{
   int  flag, index;
   Table entry;

   /*
    *   Create the Common Table and the Message Queue
    */
   if (Attach_Table() == -1)
      printf("Error in Attach_Table()\n");

   printf("Common Table initialized...\n");

   index = Search_Table("collector");
   if (index == -1) {
      printf("No such process...\n");
      exit(1);
   } 
   Read_from_Table(&entry, index);

   flag = TRUE;
   while (flag == TRUE) {
      if ((rand() / 2147483647.0) < 0.7) 
         kill(entry.process_id, EVENT_SIGNAL); 
      sleep(1);
   }
}


