/*************************************************
 * repair.c,v
*************************************************/
/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/
#ifdef VXWORKS
#include<vxWorks.h>
#endif
#include <signal.h>
#include <stdio.h>
#include <unistd.h>
#include "template.h"
#include "generic.h"

Table prt_table[25]; 
extern char this_node[];
struct var_dict_type var_dict_usr[1];
int var_number_usr= 0;
struct cmd_dict_type cmd_dict_usr[1];
int cmd_number_usr = 0;
extern char ownpname[];

#ifdef VXWORKS
repair(argv1,argv2,argv3,argv4,argv5,argv6,argv7,
     argv8,argv9,argv10) 
char *argv1,*argv2,*argv3,*argv4,*argv5,*argv6,*argv7,*argv8,*argv9,*argv10;
{
  char *argv[] = {NULL,argv1,argv2,argv3,argv4,argv5,argv6,argv7,argv8,
		    argv9,argv10}; 
  int argc = 11;
#else
main(argc, argv)
int argc;
char * argv[];
{
#endif
   int num,i;
   char status[10];
   char command[100];

#ifdef VXWORKS
   argv[0] = "repair";
   for(i=0;i<11;i++) {
     if(argv[i] == NULL || *argv[i] == '\0') {
       argc = i;
       break;
     }
   }
#endif
   strcpy(ownpname,"repair");
   if (Attach_Table() == -1) {
     printf("No Common Table\n");
     exit(-1);
   }
   Init_hostname();
   if(link_to_sp() != 0) {
     printf("Cannot link to the Status Path\n");
     exit(-1);
   }
   num = Get_Table(prt_table); 
   if(xpc_alive(num) == 0) { 
     for(i = 0;i<num;i++) {
       check_process(&(prt_table[i]),i);
     }
     unlink_sp();
   }
}

int xpc_alive(tbl_size)
int tbl_size;
{
  int i;
  int xpc_fnd;
  char tmp[100];
  FILE *fp;

  xpc_fnd = -1;
/** Try to locate the xpc in the table ***/
  for(i = 0;i<tbl_size;i++) {
/*** only on the local node ***/
    if( (prt_table[i].node[0] == '\0') ||
        (strncmp(prt_table[i].node,this_node,strlen(this_node)) == 0) ||
        (strncmp(prt_table[i].node,this_node,strlen(prt_table[i].node)) == 0)
      ) {
      if(strcmp(prt_table[i].process_name,"xpc") == 0) {
	xpc_fnd = i;
	break;
      }
    }
  }
/*** No xpc, return -1 ***/
  if(xpc_fnd == -1) {
    printf("No xpc in Common Table, so clean it.\n");
    return(0);
  }
#ifdef VXWORKS
  return(0);
#else
/*** Does the xpc exist ??? ***/
#if defined(HP) || defined(SGI)
  sprintf(tmp,"ps -ef | grep %d | grep -v grep > %s/log/xpce",
	  prt_table[i].process_id,getenv("USERUNIDAQ"));
#else
  sprintf(tmp,"ps -ux | grep %d | grep -v grep > %s/log/xpce",
	  prt_table[i].process_id,getenv("USERUNIDAQ"));
#endif
  system(tmp);
  sprintf(tmp,"%s/log/xpce",getenv("USERUNIDAQ"));
  fp = fopen(tmp,"r");
  i = fscanf(fp,"%s",tmp);
  fclose(fp);
  unlink(tmp);
  if(i > 0) {
    printf("The xpc is alive and kicking -- no repairs made.\n");
    return(1);
  }
  else {
    printf("The xpc is in the table, but it is dead -- do repairs.\n");
    return(0);
  }
#endif
}

check_process(entry,index)
Table *entry;
int index;
{
  char *node,tmp[100];
  short stpe;
  int p_stat,ps,i;

/*** Do NOT check DEAD processes ***/
  if(entry->status == DEAD) return;

/*** Do NOT check processes running on a different node ***/
  node = entry->node;
  if(node[0] != '\0'){
    if((strncmp(node,this_node,strlen(this_node)) != 0) &&
       (strncmp(node,this_node,strlen(node)) != 0)) return;
  }

/*** Now the proposed six step check: ***/

/*** Step 1: Read the status from the status-path ***/
  read_value_from_sp(entry->process_name,"proc_status",&stpe,&p_stat);
/*** Step 2: Send a busy-signal ***/
  kill(entry->process_id,BUSY_SIGNAL);
/*** Step 3: Wait to a 2 sec maximum, or until the status changed ***/
  for(i=0;i<2;i++){
#ifdef VXWORKS
    taskDelay(sysClkRateGet());
#else
    sleep(1);
#endif
    read_value_from_sp(entry->process_name,"proc_status",&stpe,&ps);
    if(ps != p_stat) break;
  }
/*** Step 4 result: Still no change, the process is dead ***/
  if(ps == p_stat) {
    remove_proc_from_sp(entry->process_name);
    Delete_MsgQ(entry->msgq_id);
    entry->status = DEAD;
    Write_to_Table(entry,index);
    return;
  }
/*** Step 5: When status used to be ALIVE, set it again ***/
  if(p_stat == ALIVE){
    sprintf(tmp,"Set proc_status = %d",ALIVE);
    Send_Message(entry->process_name,tmp);
  }
/*** Step 6: Set the appropriate status in the Status Path; though BUSY
             is not set  ***/
  if(p_stat >=BUSY) p_stat = ALIVE;
  if(entry->status !=p_stat){
    entry->status = p_stat;
    Write_to_Table(entry,index);
  }
}
