/*---------------------------------------------------------------*/
/*                                                               */
/*      Cengiz ERBAS                                             */
/*      Superconducting Super Collider Laboratory                */
/*      July 20, 1992                                            */
/*                                                               */
/*---------------------------------------------------------------*/


#include "generic.h"

/*---------------------------------------------------------------*/
/*        Definitions for the User Variable Dictionary           */
/*---------------------------------------------------------------*/
int runnr = 0, maxnevents = 0, eventnr = 0, buffnr = 0;
char eventsource[20] = "CAMAC";
int runstate = END_STATE, starttime = 0, endtime = 0;
int runtype=0, mode=0; /* v1.2 (fry) */
int flush_all = 0;

struct var_dict_type var_dict_usr[20] = {
   "runnr", INTEGER, (int) &runnr,
   "maxnevents", INTEGER, (int) &maxnevents,
   "eventnr", INTEGER, (int) &eventnr,
   "buffnr", INTEGER, (int) &buffnr,
   "eventsource", STRING, (int) eventsource, 
   "runstate", INTEGER, (int) &runstate, 
   "starttime", INTEGER, (int) &starttime,
   "endtime", INTEGER, (int) &endtime,
   "runtype", INTEGER, (int) &runtype,
   "mode", INTEGER, (int) &mode,
   "flush_all",INTEGER, (int) &flush_all,
};

int var_number_usr = 11;


/*---------------------------------------------------------------*/
/*        Definitions for the User Command Dictionary            */
/*---------------------------------------------------------------*/
int Begin();
int Pause();
int Resume();
int End();
int ExitC();
int flush_buffer();
int mset();
 
struct cmd_dict_type cmd_dict_usr[20] = {
   "BEGIN", (int (*)()) Begin,
   "PAUSE", (int (*)()) Pause,
   "RESUME", (int (*)()) Resume,
   "END", (int (*)()) End,
   "EXIT", (int (*)()) ExitC,
   "FLUSH",(int (*)()) flush_buffer,
   "MSET", (int(*)()) mset,
};
 
int cmd_number_usr = 7;
 

