/*
 *   $USERUNIDAQ/collector/pseudo_event.c
 */
/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#if defined(HP) || defined(SGI)
  unsigned int seed=7743;
# define RANBOUND 328
#else
# ifdef DEC
#   define RANBOUND 21474836
# else
#   ifdef SUN
#     define RANBOUND 21474836
#   else
#     define RANBOUND 328
#   endif
# endif
#endif

#ifdef VXWORKS
#include <wdLib.h>
extern WDOG_ID wid;
extern void wdtimeout();
#endif

pseudo_event(max_length, event_length, buf)
int *buf, *event_length;
int *max_length;
{
   int i;

   /* AAS 09/22/93 - make sure we have enough room */ 
   if ( *max_length < 100 )
      *event_length = *max_length;
   else
      *event_length = 100;
      
   /* Return random numbers in the range 0-100.    */
   for (i = 0; i < *event_length; i++) buf[i] = rand();
#if defined(HP) || defined(SGI)
   seed = buf[*event_length-1];
#endif
   for (i = 0; i < *event_length; i++) buf[i] = buf[i] / RANBOUND;
#ifdef VXWORKS
   wdStart(wid,1,(FUNCPTR)wdtimeout,0);
#endif

   return;
}

pseudo_begin()
{
#ifdef HP
  srand(seed);
#endif
  return;
}
pseudo_pause()
{return;
}
pseudo_resume()
{return;
}
pseudo_end()
{return;
}
