#!/usr/local/wish -f
#
# Unidaq DATAVIEW -- dataview.tcl
#


# Set the path for access to .tcl files
# set auto_path "$USERUNIDAQ/conf $auto_path"

set width 600
set h 300
wm title . "Prototype DATAVIEW"
wm minsize . $width $h
wm maxsize . $width $h
# following doesn't like $width and $h 
wm geometry . 600x300

#-------------------------------------------------------
# The top of the screen will have a general message, some general
# information, and the main menu.
#-----------------------------------------------------
frame .topFrame -borderwidth 1 -relief raised
message .topFrame.msg -font -Adobe-times-medium-r-normal--*-180* \
             -relief raised -borderwidth 1 \
             -text "UNIDAQ PORTABLE DATA ACQUISITION SYSTEM" \
             -foreground white -background blue -width $width
message .topFrame.msg1 -font -Adobe-times-medium-r-normal--*-180* \
             -relief raised -borderwidth 1 -text "Data Viewing Process" \
             -foreground white -background blue -width $width
button .topFrame.butExit -text "Exit" -background red \
             -command {destroy .} -width 7

place .topFrame.msg       -relx 0.  -rely 0.  -relwidth 1.  -relheight .5
place .topFrame.msg1      -relx 0.  -rely .5  -relwidth .8  -relheight .5
place .topFrame.butExit   -relx .8  -rely .5  -relwidth .2  -relheight .5
	     
#-------------------------------------------------------------
# Initialize variables; add whatever you wish to display here
#---------------------------------------------------------------
set runnr " Run Number:"
set evtnr " Event Number:"
set dt1 " Difference words 0 and 1: "

set dtcolor white
#--------------------------------------------------------------------
# Add a label for each individual parameter (you might consider one for
# the description as wel)
#---------------------------------------------------------------------
frame .evtdata -borderwidth 1 -background $dtcolor 
label .evtdata.hdrr -textvariable runnr -anchor w -background $dtcolor \
                    -borderwidth 1 -relief raised -foreground black
label .evtdata.hdre -textvariable evtnr -anchor w -background $dtcolor \
                    -borderwidth 1 -relief raised -foreground black
label .evtdata.dt1  -textvariable dt1 -anchor w -background $dtcolor \
                    -borderwidth 1 -relief raised -foreground black
#---------------------------------------------------------------------
# place it all in the window
#---------------------------------------------------------------------
place .evtdata.hdrr -relx 0.  -rely 0. -relwidth .4 -relheight .2
place .evtdata.hdre -relx .4  -rely 0. -relwidth .6 -relheight .2
place .evtdata.dt1  -relx 0.  -rely .2 -relwidth .6 -relheight .2

place .topFrame -relx 0. -rely 0. -relwidth 1. -relheight .3
place .evtdata  -relx 0. -rely .3 -relwidth 1. -relheight .7

proc getdata { } {
    if { [nova_get] != -1 } {
      while { [next_event] == 0 } {
	display_data
      }
      nova_put
    }
    after 500 getdata
}

#----------------------------------------------------------
# The events are read in, now fill the display variables
# with whatever you like checking on a lot or not at all
#---------------------------------------------------------
proc display_data { } {
	global runnr evtnr dt1

	set runnr " Run Number: [event_header 2]"
	set i [event_header 1] 
	if { $i == 0 } {
	  set evtnr " Event Number: [event_header 3]"
	  set i [event_data 0 INTEGER]
	  set j [event_data 1 INTEGER]
	  if { $j < $i } {
	   set k [expr $i - $j ]
	  } else {
	   set k [expr $j - $i]
	  }
	  set dt1 " Difference words 0 and 1: $k"
	} elseif { $i == 1 } {
	  set evtnr " Event Number: Beginning..."
	} elseif { $i == 2 } {
	  set evtnr " Event Number: [event_header 3]. Paused"
	} elseif { $i == 3 } {
	  set evtnr " Event Number: Resuming..."
	} elseif { $i == 4 } {
	  set evtnr " Event Number: [event_header 3]. Ended"
	}
}

#--------------------------------------------------
# Start reading data
#--------------------------------------------------
getdata 




