#!/usr/local/wish -f
#
# Unidaq graphical user interface -- operator.tcl
#
global ownpname

# Set the path for access to .tcl files
# set auto_path "$USERUNIDAQ/conf $auto_path"
#
# set width and height for the User interface window....
#
set width 800
set h 390
wm title . "Unidaq Prototype Demonstration"
wm minsize . $width $h
wm maxsize . $width $h
#
# following doesn't like $width and $h 
#
wm geometry . 800x390
#
# The setting of additional parameters
#
set holdparam 0
set opcancel 0
set runup 0
set runcontrol "runco"
set collector [proc_var $runcontrol collector]
set recorder [proc_var $runcontrol  recorder]
#
# General procedures
#
proc blnk { wndw bg fg } {
  if { [winfo exists $wndw] == 1 } {
    $wndw config -foreground $fg
    after 400 blnk $wndw $fg $bg
  }
}
#
# Create a frame completely overlapping the top one, so 
# it is possible to inhibit input in the runparameters window
#
frame .msk
#
# The Update procedure, used to display the correct time in window wn
#
proc update { wn } {
   if { [winfo exists $wn] == 1 } {
	 $wn config -text [exec date "+%H:%M"]
	 after 55000 update $wn
   } else {
   	 after 100 update $wn
   }
}
#
# The top of the screen will have a general message, some general
# information, and an exit button
#
frame .msk.topFrame -borderwidth 1
message .msk.topFrame.msg -font -Adobe-times-medium-r-normal--*-180* \
             -relief flat -borderwidth 0 \
             -text "UNIDAQ PORTABLE DATA ACQUISITION SYSTEM" \
             -foreground white -background blue -width $width
message .msk.topFrame.msg1 -font -Adobe-times-medium-r-normal--*-180* \
             -relief flat -borderwidth 0 -text "General User Interface" \
             -foreground white -background blue -width $width
label .msk.topFrame.labelUname -text "User name: $env(LOGNAME)" \
	     -foreground white -background blue 
label .msk.topFrame.labelHname -text "Host name: [exec uname -n]" \
	     -foreground white -background blue
label .msk.topFrame.labelHtype -text "Host type: [exec uname -s]" \
	     -foreground white -background blue
label .msk.topFrame.labelDate -text [ update .msk.topFrame.labelDate ] \
	     -relief flat -width 10 -foreground white -background blue 
button .msk.topFrame.butExit -text "Exit" -background red \
             -command {destroy .} -width 7

place .msk.topFrame.msg         -relx 0.   -rely 0.   \
				-relwidth 1.   -relheight .333
place .msk.topFrame.msg1        -relx 0.   -rely .334 \
				-relwidth 1.   -relheight .333
place .msk.topFrame.labelUname  -relx 0.   -rely .667 \
				-relwidth .25  -relheight .333
place .msk.topFrame.labelHname  -relx .25  -rely .667 \
				-relwidth .25  -relheight .333
place .msk.topFrame.labelHtype  -relx .5   -rely .667 \
				-relwidth .25  -relheight .333
place .msk.topFrame.labelDate   -relx .75  -rely .667 \
				-relwidth .125 -relheight .333
place .msk.topFrame.butExit     -relx .875 -rely .667 \
				-relwidth .125 -relheight .333
#
# Next the runparameters frame, This will NOT be put in msk
#
frame .runpar -borderwidth 2 -background blue -relief raise
label .runpar.top -text "Run and Storage parameters" -background blue \
                  -foreground white -font *-times-medium-r-normal--*-180-*
#
# To make things easier, procedure addrunp is used to add runparameters to 
# the display. The arguments are:
# addrunp windowname label-text variable-name relative-label-size 1/0 
# a 1 means that the argument can be modified by user
#
proc addrunp { a atext avar lsiz uvar } {
    label $a.lab -text "$atext" -foreground white -background blue -anchor w
    if { $uvar == 1} {
        entry $a.ent -relief raise -background white -textvariable $avar \
	             -foreground black -borderwidth 1 -width 10
    } else {
        label $a.ent -relief raise -background blue -textvariable $avar \
	             -foreground white -borderwidth 1 -width 10 -anchor w
    }
    place $a.lab -relx 0 -rely 0 -relwidth $lsiz -relheight 1
    place $a.ent -relx $lsiz -rely 0 -relwidth [expr 1.-$lsiz] -relheight 1
}

frame .runpar.sink
addrunp .runpar.sink "Storage: " sink .25 1
frame .runpar.sdev
label .runpar.sdev.lab -textvariable sinklab -foreground white \
	-background blue -anchor w
entry .runpar.sdev.ent -relief raise -background white -textvariable sinkdev \
	-foreground black -borderwidth 1 -width 10
place .runpar.sdev.lab -relx 0 -rely 0 -relwidth .25 -relheight 1
place .runpar.sdev.ent -relx .25 -rely 0 -relwidth .75 -relheight 1

frame .runpar.runnr
addrunp .runpar.runnr "Runnr: " runnr .5 1
frame .runpar.source
addrunp .runpar.source "Event source: " source .5 1
frame .runpar.ttime
addrunp .runpar.ttime "Start time: " ttime .25 0
frame .runpar.maxev
addrunp .runpar.maxev "Max. Events: " maxev .5 1
frame .runpar.evnr
addrunp .runpar.evnr "Event Number: " evnr .5 0
frame .runpar.ptime
addrunp .runpar.ptime "End Time: " ptime .25 0
frame .runpar.status
addrunp .runpar.status "Status: " status .5 0

place .runpar.top -relx 0 -rely 0 -relwidth 1. -relheight .14
place .runpar.sink -relx 0 -rely .19 -relwidth .96 -relheight .11
place .runpar.sdev -relx 0 -rely .30 -relwidth .96 -relheight .11
place .runpar.runnr -relx 0 -rely .44 -relwidth .48 -relheight .11
place .runpar.source -relx 0 -rely .55 -relwidth .48 -relheight .11
place .runpar.status -relx 0 -rely .66 -relwidth .48 -relheight .11
place .runpar.maxev -relx .5 -rely .44 -relwidth .48 -relheight .11
place .runpar.evnr -relx .5 -rely .55 -relwidth .48 -relheight .11
place .runpar.ttime -relx 0 -rely .77 -relwidth .96 -relheight .11
place .runpar.ptime -relx 0 -rely .88 -relwidth .96 -relheight .11

proc rpup {} {
# This procedure updates the runparameters frequently
  global runnr source ttime maxev evnr ptime status sink holdparam 
  global sinklab sinkdev
  global collector recorder

  if {$holdparam == 1} {
#   No update temporarily, except on sinkdev window label
    if { [string tolower $sink] == "dummy" } {
      set sinklab "device/directory:"
      set sinkdev "none"
    } elseif { [string tolower $sink] == "tape" } {
      set sinklab "device:"
    } elseif { [string tolower $sink] == "disk" } {
      set sinklab "directory:"
    }
    after 1000 rpup
  } else {
    set runnr [proc_var $collector runnr]
    set source [proc_var $collector eventsource]
    set maxev [proc_var $collector maxnevents]
    set evnr [proc_var $collector eventnr]
    set tt [proc_var $collector starttime]
    if { $tt == 0 } {
      set ttime ""
    } else {
      set ttime [date_val $tt]
    } 
    set tt [proc_var $collector endtime]
    if { $tt == 0 } {
      set ptime ""
    } else {
      set ptime [date_val $tt]
    } 
    set pp [proc_var $collector runstate]
    if {$pp >= 0 && $pp <4 } {
      set status [lindex {Idle Begin Pause Run} $pp]
      runco_colors
    } else {
      set status $pp
    }
    set sink [proc_var $recorder eventsink]
    if { [string tolower $sink] == "dummy" } {
      set sinklab "device/directory:"
      set sinkdev "none"
    } elseif { [string tolower $sink] == "tape" } {
      set sinklab "device:"
      set sinkdev [proc_var $recorder device]
    } else {
      set sinklab "directory:"
      set sinkdev [proc_var $recorder dest_dir]
    }
    if { $sink == "Error in read_value" }  {
      set sink "No recorder process found"
      set sinklab "device/directory:"
      set sinkdev "none"
    }
    after 5000 rpup
  }
}

#
# And NOW... some procedures that will/can be used by clicking the 
# runcontrol buttons
#
proc hidebuttons {} {
# hide the runco buttons behind a frame
  global status .msk.runco 

  if { [ winfo exist .msk.runco.hid] == 0 } {
    frame .msk.runco.hid 
    place .msk.runco.hid -relx 0 -rely .15 -relwidth 1. -relheight .85
    runco_colors
  }
}

proc displaybuttons {} {
# remove the frame that hides the buttons
  global .msk.runco

  if { [ winfo exist .msk.runco.hid] == 1 } {
    destroy .msk.runco.hid
  }
}

proc runco_colors {} {
# set the right colors for the runcontrol windows
  global status

  if { $status == "Idle" } { 
    set bgcol #3d2 
    set fgcol white
  } elseif { $status == "Run" } {
    set bgcol red
    set fgcol white
  } else {
    set bgcol yellow
    set fgcol black
  }
  if { [ winfo exist .msk.runco ] == 1 } {
    .msk.runco config -background $bgcol 
    .msk.runco.top config -background $bgcol -foreground $fgcol
  }
  if { [ winfo exist .msk.runco.hid] == 1 } {
    .msk.runco.hid config -background $bgcol 
  }
}

proc newrp {} {
# Update runparameters
  global holdparam opcancel runup runnr maxev source sink runcontrol collector 
  global sinklab sinkdev
  global recorder .msk

  set holdparam 1
  upd_runnr
  set sinklab "device/directory:"
  grab release .msk
  confirm "Parameters are correct" "Cancel operation" 
  if { $opcancel == 0 } {
    ask $runcontrol set runnr = $runnr
    ask $collector set runnr = $runnr
    ask $collector set maxnevents = $maxev
    ask $collector set eventsource = $source
    if { [string tolower $sink] == "dummy" } {
      catch {ask $recorder set eventsink = $sink}
    } elseif { [string tolower $sink] == "tape" } {
      catch {ask $recorder set eventsink = tape}
      catch {ask $recorder set device = $sinkdev}
    } else {
      catch {ask $recorder set eventsink = disk}
      catch {ask $recorder set dest_dir = $sinkdev}
    }
  } else {
    set runnr [proc_var $collector runnr]
    set source [proc_var $collector eventsource]
    set maxev [proc_var $collector maxnevents]
    set sink [proc_var $recorder eventsink]
    if { [string tolower $sink] == "dummy" } {
      set sinklab "device/directory:"
      set sinkdev "none"
    } elseif { [string tolower $sink] == "tape" } {
      set sinklab "device:"
      set sinkdev [proc_var $recorder device]
    } else {
      set sinklab "directory:"
      set sinkdev [proc_var $recorder dest_dir]
    }
    if { [string tolower $sink] != "dummy" } {
      set sink [proc_var $recorder dest_dir]
    }
    incr runup -1
  }
  grab set .msk
  set holdparam 0
}

proc upd_runnr {} {
# Adds 1 to the runnr when needed
  global runnr runup

  if {$runnr != 0 && $runup == 0 } {
    incr runnr 1
  }
  incr runup 1
}
#
# Next the runcontrol frame, This will be put in msk
#

frame .msk.runco -borderwidth 1 -background yellow -relief raised
label .msk.runco.top -background yellow -foreground black \
         -text "Run control commands" -font *-times-medium-r-normal--*-180-*
button .msk.runco.initButton -text "Initialize" -background blue \
         -foreground white -command \
          { if { ($status == "Idle") && ($privilege == 1) } { initialize } }
button .msk.runco.bcButton -text "Begin Cold" -background blue \
         -foreground white -command \
          { if { ($status == "Idle") && ($privilege == 1) } { beginrun cold } }
button .msk.runco.bwButton -text "Begin Warm" -background blue \
         -foreground white -command \
          { if { ($status == "Idle") && ($privilege == 1) } { beginrun warm } }
button .msk.runco.resButton -text "Continue" -background blue \
         -foreground white -command \
          { if { ($status == "Pause") && ($privilege == 1) } { continuerun } }
button .msk.runco.pauseButton -text "Suspend" -background blue \
         -foreground white -command \
          { if { ($status == "Run") && ($privilege == 1) } { pauserun } } 
button .msk.runco.endButton -text "End" -background blue \
         -foreground white -command \
          { if { ($status != "Idle") && ($privilege == 1) } { stoprun } }

place .msk.runco.top         -relx 0  -rely 0   -relwidth 1   -relheight .15
place .msk.runco.bcButton    -relx .1 -rely .2  -relwidth .35 -relheight .2
place .msk.runco.resButton   -relx .1 -rely .45 -relwidth .35 -relheight .2
place .msk.runco.endButton   -relx .1 -rely .7  -relwidth .35 -relheight .2
place .msk.runco.bwButton    -relx .6 -rely .2  -relwidth .35 -relheight .2
place .msk.runco.pauseButton -relx .6 -rely .45 -relwidth .35 -relheight .2
place .msk.runco.initButton  -relx .6 -rely .7  -relwidth .35 -relheight .2
#
# Procedures needed with runcontrol buttons
#
proc initialize {} {
  global opcancel

  hidebuttons
  confirm "Continue Initialization" "Cancel Initialization" 
  if {$opcancel == 0} {
    newrp
  }
  displaybuttons
}

proc beginrun { opt } {
  global opcancel runcontrol runup runnr collector

  hidebuttons
  if { $opt == "cold" } {
    confirm "Continue Start cold" "Cancel start cold" 
    if {$opcancel == 0} {
      newrp
      if {$opcancel == 0} {
        initruncmt 1
        ask $runcontrol BEGIN_RUN_TCL
        set runup 0
      }
    }
  } else {
    confirm "Continue Start warm" "Cancel start warm" 
    if {$opcancel == 0} {
      upd_runnr
      ask $runcontrol set runnr = $runnr
      ask $collector set runnr = $runnr
      initruncmt 1
      ask $runcontrol BEGIN_RUN_TCL
      set runup 0
    }
  }
  displaybuttons
  set opcancel 0
}

proc continuerun { } {
  global opcancel runcontrol

  hidebuttons
  confirm "confirm: Continue run" "Cancel operation" 
  if {$opcancel == 0} {
#      initruncmt 3
    ask $runcontrol CONTINUE_RUN
  }
  displaybuttons
  set opcancel 0
}

proc pauserun { } {
  global opcancel runcontrol

  hidebuttons
  confirm "continue Suspend run" "Cancel operation" 
  if {$opcancel == 0} {
#      initruncmt 2
    ask $runcontrol SUSPEND_RUN
  }
  displaybuttons
  set opcancel 0
}

proc stoprun { } {
  global opcancel runcontrol

  hidebuttons
  confirm "continue Stop run" "Cancel operation" 
  if {$opcancel == 0} {
#      initruncmt 4
    ask $runcontrol STOP_RUN
  }
  displaybuttons
  set opcancel 0
}

#
# Add a command line
#
proc clinecom {} {
# What to do with commands on the command line
  global rcommand privilege privitext  runcontrol ownpname

  set rcfirst [ string tolower [lindex  $rcommand  0] ]
  if { $rcfirst == "exit" } {
    destroy .
  } elseif { $rcfirst == "privi" } {
    if { $ownpname == "[ proc_var $runcontrol operator ]"} { 
      set privilege 1
      set privitext "PRIVILEGED"
      displaybuttons
    }
  } elseif { $rcfirst == "noprivi" } {
    set privilege 0
    set privitext "NOT PRIVILEGED"
    hidebuttons
  } elseif { $rcfirst == "set" } {
    if { [lindex $rcommand  1 ] == "runcontrol" } {
      if { [lindex $rcommand 2] == "=" } {
        set runcontrol [lindex $rcommand 3]
        update_runco
      }
    } else {
      if { $privilege == 1 } { ask $runcontrol $rcommand }
    }
  } else { 
    if { $privilege == 1 } { ask $runcontrol $rcommand }
  }
  set rcommand ""
}

proc initruncmt { opt } {
  if { $opt == 1 } {
    runcmt "Enter Begin Run Comment"
  }
  if { $opt == 2 } {
    runcmt "Enter Pause Run Comment"
  }
  if { $opt == 3 } {
    runcmt "Enter Resume Run Comment"
  }
  if { $opt == 4 } {
    runcmt "Enter End Run Comment"
  }
}

proc runcmt { comm_prompt } {
# A run comment, with the comment passed to runcontrol.
  global opcancel .msk.cline status rcommand

  label .msk.cline.top2 -text $comm_prompt -foreground black \
                 -background yellow -font *-times-medium-r-normal--*-180-*
  label .msk.cline.lab2 -text "comment >> " -foreground black \
                 -background yellow 
  entry .msk.cline.command2 -relief raise -background white -foreground black \
      -textvariable rcommand -borderwidth 1 
  bind .msk.cline.command2 <KeyPress-Return> { \
	        ask $runcontrol re:prompt $rcommand ; \
		ask $runcontrol set wait_for = 0 ; \
		destroy .msk.cline.top2 ; destroy .msk.cline.lab2 ; \
		destroy .msk.cline.command2 }

  place .msk.cline.top2 -relx 0.0 -rely 0. -relwidth 1. -relheight .5
  place .msk.cline.lab2 -relx 0.0 -rely .5 -relwidth 0.12 -relheight .5
  place .msk.cline.command2 -relx 0.12 -rely .5 -relwidth 0.88 -relheight .5
  blnk .msk.cline.top2 yellow black
  blnk .msk.cline.lab2 yellow black
  tkwait window .msk.cline.top2
  set rcommand ""
}

proc confirm { ytext ntext } {
# display the confirmation buttons
global opcancel .msk.cline  status rcommand

  runco_colors
  button .msk.cline.butfram -text $ytext -foreground white -background #3d2 \
      -command {set opcancel 0 ; \
         destroy .msk.cline.butfram ; destroy .msk.cline.butfrnok }
  button .msk.cline.butfrnok -text $ntext -foreground white -background red \
      -command {set opcancel 1 ; \
       destroy .msk.cline.butfram ; destroy .msk.cline.butfrnok }
  place .msk.cline.butfram -relx 0.0 -rely 0 -relwidth .5 -relheight 1
  place .msk.cline.butfrnok -relx 0.5 -rely 0 -relwidth .5 -relheight 1
  tkwait window .msk.cline.butfrnok
}

frame .msk.cline -borderwidth 1 -relief raised -background yellow
label .msk.cline.top -text "Run control commands" -foreground black \
           -background yellow -font *-times-medium-r-normal--*-180-*
label .msk.cline.lab -text "command >> " -foreground black -background yellow
entry .msk.cline.command -relief raise -background white \
           -textvariable rcommand -foreground black -borderwidth 1 -width 10

place .msk.cline.top -relx 0.0 -rely 0. -relwidth 1. -relheight .5
place .msk.cline.lab -relx 0.0 -rely .5 -relwidth 0.12 -relheight .5
place .msk.cline.command -relx 0.12 -rely .5 -relwidth 0.88 -relheight .5

bind .msk.cline.command <KeyPress-Return> { clinecom }
#
# A window displaying the current processes
#
proc update_runco {} {
  global runcontrol .msk.prfrm

  .msk.prfrm.runco configure -text "runcontrol: $runcontrol"
}

proc checkproc {} {
  global runcontrol collector recorder .msk.prfrm

  set collector [proc_var $runcontrol collector]
  .msk.prfrm.coll configure -text "collector:  $collector"
  set recorder [proc_var $runcontrol  recorder]
  .msk.prfrm.rec configure -text "recorder:   $recorder"
  after 5000 checkproc
}

frame .msk.prfrm -borderwidth 1 -relief sunken -background #3d2
label .msk.prfrm.tp -background #3d2 -foreground white \
          -text "Processes in Use" -font *-times-medium-r-normal--*-180-*
label .msk.prfrm.runco -background #3d2 -foreground white \
          -text "runcontrol: $runcontrol" -anchor w
label .msk.prfrm.coll -background #3d2 -foreground white \
          -text "collector:  $collector" -anchor w
label .msk.prfrm.rec -background #3d2 -foreground white \
          -text "recorder:   $recorder"  -anchor w

place .msk.prfrm.tp -relx 0 -rely 0 -relwidth 1. -relheight .35
place .msk.prfrm.runco -relx 0 -rely .35 -relwidth 1. -relheight .2
place .msk.prfrm.coll -relx 0 -rely .55 -relwidth 1. -relheight .2
place .msk.prfrm.rec -relx 0 -rely .75 -relwidth 1. -relheight .2
#
# Display the privilege
#
label .msk.privilege -background blue -foreground white \
          -textvariable privitext  -font *-times-medium-r-normal--*-180-*

##############################################################
# Place it all in a window
##############################################################
place .msk.topFrame  -relx 0.  -rely 0.   -relwidth 1.  -relheight .231 
place .msk.runco     -relx .65 -rely .231 -relwidth .35 -relheight .385
place .msk.privilege -relx 0   -rely .769 -relwidth .65 -relheight .077
place .msk.prfrm     -relx .65 -rely .616 -relwidth .35 -relheight .230
place .msk.cline     -relx 0.  -rely .846 -relwidth 1.  -relheight .154

place .msk -relx 0.0 -rely 0.0 -relwidth 1.0 -relheight 1.
place .runpar -relx 0 -rely 0.231 -relwidth .65 -relheight .538

#
# Finally, The initial situation, and starting of background routines
#
set privilege 0
set privitext "NOT PRIVILEGED"
hidebuttons
grab set .msk

rpup 
checkproc
