/*************************************
 This file is modified for dataview1
        (original: dataconv.c)
           on 6 Dec.1994
           by M.Tairadate.
**************************************/
/********************************************************************
 File dataconv.c: contains the conversion routines from data to 
                  string
 author: C. Timmermans.
 ********************************************************************/

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/
#include "template.h"


/*****************************************************************
 The conversion routines have the following form:

  routine(header,data,txt)
  int *header,*data;
  char *txt;
  {
  *************************************************************
  Using the header and the data-buffer, one has to fill the txt
  character string. As an example I will fill txt with the 
  hexadecimal rep. of the first dataword, but only if this 
  data corresponds to an actual event
  **************************************************************
  if(header[1] == EVENT_RECORD) sprintf(txt,"%x",data[0]);
  else strcpy(txt,"No Dataword");
  }
******************************************************************/
gen_num(header,data,txt)
int *header,*data;
char *txt;
{
  if(header[1] == BEGINRUN_RECORD) strcpy(txt,"Begin");
  else if(header[1] == PAUSERUN_RECORD) strcpy(txt,"Pause");
  else if(header[1] == ENDRUN_RECORD) strcpy(txt,"End");
  else if(header[1] == RESUMERUN_RECORD) strcpy(txt,"Resume");
  else if(header[1] == EVENT_RECORD) sprintf(txt,"%d",data[0]);
  else strcpy(txt,"Unknown runstate");
}

