/*****************************************************************
 dataview.c The interactions with NOVA and the X server
 author: C. Timmermans
 ******************************************************************/
/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include "dataview.h"
#include "template.h"

#include "nova.h"
#define NOVA_HOSTNAME_MAX  32    /*  extracted from novanet.h   */
#define DEFAULT_NAME     "/tmp/nova"
#define DEFAULT_PRI      21

int Process_Event();
void Process_Idle();
extern char *get_name_from_args();
extern long send_err_mess();

struct   NOVAD *nd;
int *data, length;

int run_number  = -1;

XEvent report;

main(argc, argv)
int argc;
char * argv[];
{
  char name[NV_MAXNAME + 1];
  char sec_name[NV_MAXNAME + NOVA_HOSTNAME_MAX + 1];
  short s;
   
  init_datawin();
  if(Template_Init(get_name_from_args(argc,argv)) < 0){
    printf("Process of name %s already exists\n",
	   get_name_from_args(argc,argv));
    printf("Please use -n to set a different name\n");
    exit(0);
  }

  UNI_nova_parms(DEFAULT_NAME, DEFAULT_PRI, name, sec_name);
  if ((int)(nd = (struct NOVAD *)UNI_nova_open(name, nova_prio, 1)) 
               == -1) {
      printf("Error in opening nova...\n");
      Send_Message ( ownpname, "EXIT" );
  }

  Template_Main((int (*)())Process_Event, NULL, (void (*)())Process_Idle);
  UNI_nova_close(nd);
}

int Process_Event()
{
  int status;
  int run_num,pos = 0;
  
  status = UNI_nova_get(nd, &data, &length);
  if (status != 0) return (FALSE); 

  while (pos*4 < length) {
    if (data[pos] == 0) break;
    update_datawin(&(data[pos]));
    while(gui_pending()){
      gui_next(&report);
      execute_datawin();
    }
    pos += data[pos];
  }
  UNI_nova_put(nd, data, length, 0); 
  return (TRUE);
}


void Process_Idle()
{
/**** wait for X events here ****/
  while(gui_pending()){
    gui_next(&report);
    execute_datawin();
  }
}

