/*******************************************************************
 file datawin.c describes the actions of all windows on window-manager
                messages
 author: C. Timmermans
 *********************************************************************/
/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/
#include <X11/Xlib.h>
#include <stdlib.h>
#include <stdio.h>
#include "datawin.h"

extern XEvent report;

Window datawin;
GC dwGC;

Window dw_bt[MAX_N_SL_DATA];
GC dw_btGC[MAX_N_SL_DATA];
char dw_txt[MAX_N_SL_DATA][100];

init_datawin()
{
  int i,but_x,but_y,ysiz;

  if(gui_init(NULL) < 0){
    perror("Cannot initialize the display\n");
    exit(1);
  }

  if(n_sl_data > MAX_N_SL_DATA) n_sl_data = MAX_N_SL_DATA;

  ysiz = 30+40*((n_sl_data + 1)/2);
  gui_window(&datawin,&dwGC,0,600,ysiz,15,650,4,0,"Data View");
  for(i = 0; i<n_sl_data;i++){
    but_x = 110+310*(i%2);
    but_y = 25 + 40*(i/2);
    gui_window(&(dw_bt[i]),&(dw_btGC[i]),&datawin,160,30,but_x,but_y,1,0,"");
  }
  gui_display(&datawin);
  for(i = 0; i<n_sl_data;i++) gui_display(&(dw_bt[i]));
}

update_datawin(dt)
int *dt;
/********************************************
 This routine is only called when new data is
 received
 ********************************************/
{
  char tmp[100];
  int i;

  for(i = 0;i<n_sl_data;i++){
    strcpy(dw_txt[i],tmp);
    dview[i].conversion(dt,&(dt[6]),tmp);
    if(strcmp(tmp,dw_txt[i]) != 0){
      strcpy(dw_txt[i],tmp);
      gui_clear(&(dw_bt[i]));
      gui_text(&(dw_bt[i]),&(dw_btGC[i]),5,20,dw_txt[i]);
    }
  }
}

execute_datawin()
{
  int i;

  if(report.xkey.window == datawin)          update_data_win();
  else {
    for(i = 0;i<n_sl_data;i++){
      if(report.xkey.window == dw_bt[i]){
        update_dw_but(i);
        return;
      }
    }
  }
}

update_data_win()
{
  int i,tx_x,tx_y;

  switch(report.type) {
  case Expose:
    for(i = 0; i<n_sl_data;i++){
      tx_x = 10+310*(i%2);
      tx_y = 45 + 40*(i/2);
      gui_text(&datawin,&dwGC,tx_x,tx_y,dview[i].txt);
    }
    break;
  }
}

update_dw_but(but)
int but;
{
  switch(report.type) {
  case Expose:
    gui_text(&(dw_bt[but]),&(dw_btGC[but]),5,20,dw_txt[but]);
    break;
  }
}
